using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace TestDropdownRenderer
{
	/// <summary>
	/// Summary description for DropDownUser.
	/// </summary>
	public class DropDownUser : System.Windows.Forms.UserControl
	{
		public event EventHandler SaveValues;
		public event EventHandler CancelValues;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button cancelButton;
        private System.Windows.Forms.Button okButton;
		private System.ComponentModel.Container components = null;

		private bool initDone = false;
        private CheckedListBox checkedListBox1;
		//used to indicate changes to the values
		private bool changed = false;
		
		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.panel1 = new System.Windows.Forms.Panel();
            this.cancelButton = new System.Windows.Forms.Button();
            this.okButton = new System.Windows.Forms.Button();
            this.checkedListBox1 = new System.Windows.Forms.CheckedListBox();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.SystemColors.Control;
            this.panel1.Controls.Add(this.cancelButton);
            this.panel1.Controls.Add(this.okButton);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel1.Location = new System.Drawing.Point(3, 109);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(162, 48);
            this.panel1.TabIndex = 2;
            // 
            // cancelButton
            // 
            this.cancelButton.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.cancelButton.Location = new System.Drawing.Point(72, 16);
            this.cancelButton.Name = "cancelButton";
            this.cancelButton.Size = new System.Drawing.Size(64, 23);
            this.cancelButton.TabIndex = 1;
            this.cancelButton.Text = "Cancel";
            this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
            // 
            // okButton
            // 
            this.okButton.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.okButton.Location = new System.Drawing.Point(8, 16);
            this.okButton.Name = "okButton";
            this.okButton.Size = new System.Drawing.Size(58, 23);
            this.okButton.TabIndex = 0;
            this.okButton.Text = "OK";
            this.okButton.Click += new System.EventHandler(this.okButton_Click);
            // 
            // checkedListBox1
            // 
            this.checkedListBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.checkedListBox1.CheckOnClick = true;
            this.checkedListBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.checkedListBox1.FormattingEnabled = true;
            this.checkedListBox1.Items.AddRange(new object[] {
            "Choice1",
            "Choice2",
            "Choice3",
            "Choice4"});
            this.checkedListBox1.Location = new System.Drawing.Point(3, 3);
            this.checkedListBox1.Name = "checkedListBox1";
            this.checkedListBox1.Size = new System.Drawing.Size(162, 105);
            this.checkedListBox1.TabIndex = 3;
            this.checkedListBox1.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.checkedListBox1_ItemCheck);
            // 
            // DropDownUser
            // 
            this.BackColor = System.Drawing.Color.RosyBrown;
            this.Controls.Add(this.checkedListBox1);
            this.Controls.Add(this.panel1);
            this.Name = "DropDownUser";
            this.Padding = new System.Windows.Forms.Padding(3);
            this.Size = new System.Drawing.Size(168, 160);
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		public DropDownUser(ArrayList stringVals)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			SetListOfStringValues(stringVals);

			initDone = true;
		}

		public void SetListOfStringValues(ArrayList stringVals)
		{
            string fitString = "";
            Graphics graphics = this.checkedListBox1.CreateGraphics();
            this.checkedListBox1.Items.Clear();

            foreach (string newVal in stringVals)
            {
                this.checkedListBox1.Items.Add(newVal);
                fitString = newVal.Length > fitString.Length ? newVal : fitString;
            }
            SizeF size = graphics.MeasureString(fitString, this.checkedListBox1.Font);
            int width = (int)size.Width + 30;
            if (this.Size.Width < width)
                this.Size = new Size(width, this.Height);
		}
		public void SetValuesFromString(string val)
		{
			string s;
			string temp = ", " + val + ',';
			bool checkItem = false;
			
			changed = false;
			
			for(int i = 0; i < this.checkedListBox1.Items.Count; ++i)
			{
				s = this.checkedListBox1.Items[i].ToString();
				
				checkItem = (temp.IndexOf(", " + s + ',') > -1);
				this.checkedListBox1.SetItemChecked(i, checkItem); 
			}
		}


		public string GetValuesToString()
		{
			string val = "";
			int i = 0;
			foreach(object s in this.checkedListBox1.Items)
			{
				if(this.checkedListBox1.GetItemChecked(i))
				{
					if(val.Length > 0)
						val += ", ";
					val += s.ToString();
				}
				i += 1;
			}
			return val;
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			changed = false;
			if (CancelValues != null)
				CancelValues(this, EventArgs.Empty);
		}

		private void okButton_Click(object sender, System.EventArgs e)
		{
			bool saveChanged = this.changed;
			this.changed = false;
			if(saveChanged && SaveValues != null)
				SaveValues(this, EventArgs.Empty);
			else if (CancelValues != null)
				CancelValues(this, EventArgs.Empty);
		}


		private void checkedListBox1_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
		{
			if(!this.initDone)
				return;

			changed = true;
		}

	}
}
