using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;

namespace TestDropdownRenderer
{
    public partial class GridDialog : Form
    {
        string changedText = "";
        public GridDialog()
        {
            InitializeComponent();
            string cellType = "Drop Down1";

            AddValues(cellType);
            gridControl1[1, 1].CellType = cellType;
            gridControl1[1, 1].Text = "Test1, Test2";
            AddValues("Drop Down 2");
            gridControl1[1, 2].CellType = "Drop Down 2";
            gridControl1[1, 2].Text = "Test1, Test2";

            AddValues("Drop Down 3");
            gridControl1[2, 1].CellType = "Drop Down 2";
            gridControl1[2, 1].Text = "Test2, Test1";
            AddValues("Drop Down 4");
            gridControl1[2, 2].CellType = "Drop Down 4";
            gridControl1[2, 2].Text = "Test2, Test1";
            gridControl1.ColWidths.ResizeToFit(GridRangeInfo.Cols(1, 2), GridResizeToFitOptions.IncludeHeaders);
        }

        private void AddValues(string cellType)
        {
            if (!gridControl1.CellModels.ContainsKey(cellType))
            {
                ArrayList values = new ArrayList();
                values.Add("Test1");
                values.Add("Test2");
                values.Add("Test3");
                gridControl1.CellModels.Add(cellType, new DropDownUserCellModel(gridControl1.Model, new DropDownUser(values)));
            }
        }

        private void buCancel_Click(object sender, EventArgs e)
        {
            Cancel();
        }
        /// <summary>
        /// Clear values in the first column
        /// </summary>
        private void Cancel()
        {
            gridControl1[1, 1].Text = "";
            gridControl1[2, 1].Text = "";
            this.DialogResult = DialogResult.Cancel;
        }
        /// <summary>
        /// Cancel values in first column on form close
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void GridDialog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if( e.CloseReason == CloseReason.UserClosing)
                Cancel();
        }

        private void buOk_Click(object sender, EventArgs e)
        {

        }
        /// <summary>
        /// Added this event handler as when the cell is changed, the changed value has to be retrieved.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void gridControl1_CurrentCellChanged(object sender, EventArgs e)
        {
            GridControl grid = sender as GridControl;
            //need to call this here so that i can get the changed value.
            grid.CurrentCell.EndEdit();
            int row = grid.CurrentCell.RowIndex;
            int col = grid.CurrentCell.ColIndex;
            //need to save this text
            changedText = grid[row, col].Text;
        }
    }
}